
#include "Utils.h"

// Change a STL string to lower case
string makeLower(const string& strA)
{
	string strLowerA = "";
	unsigned int i = 0;
	unsigned int iLenA = (unsigned int) strA.length();

	for (i = 0; i < iLenA; i++)
	{
	  strLowerA += tolower(strA[i]);
	}

	return strLowerA;
}

// Change a STL string to upper case
string makeUpper(const string& strA)
{
	string strUpperA = "";
	unsigned int i = 0;
	unsigned int iLenA = (unsigned int) strA.length();

	for (i = 0; i < iLenA; i++)
	{
	  strUpperA += toupper(strA[i]);
	}

	return strUpperA;
}

// Checks for a command line switch with no following argument
bool getSwitch(int argc, char** argv, const string& strSwitch)
{
	string strLowerSwitch = makeLower(strSwitch);
	for (int i = 1; i < argc; i++)
	{
		string strArg = makeLower(argv[i]);
		if ((strArg.find(strLowerSwitch) == 1) && 
			((strArg[0] == '/') || (strArg[0] == '-')))
		{
			return true;
		}
	}
	return false;
}

// Look for a command line switch with the given name and followed by a single string parameter
bool getSwitch(int argc, char** argv, const string& strSwitch, string* pResult)
{
	if (!pResult)
		return false;
	string strLowerSwitch = makeLower(strSwitch);
	for (int i = 1; i < argc - 1; i++)
	{
		string strArg = makeLower(argv[i]);
		if ((strArg.find(strLowerSwitch) == 1) && 
			((strArg[0] == '/') || (strArg[0] == '-')))
		{
			*pResult = argv[i + 1];
			return true;
		}
	}
	return false;
}

// Look for a command line switch with the given name and followed by one integer parameters
bool getSwitch(int argc, char** argv, const string& strSwitch, int* pResult1)
{
	if (!pResult1) 
		return false;
	string strLowerSwitch = makeLower(strSwitch);
	for (int i = 1; i < argc - 1; i++)
	{
		string strArg = makeLower(argv[i]);
		if ((strArg.find(strLowerSwitch) == 1) && 
			((strArg[0] == '/') || (strArg[0] == '-')))
		{
			*pResult1 = atoi(argv[i + 1]);
			return true;
		}
	}
	return false;
}

// Look for a command line switch with the given name and followed by one integer parameters
bool getSwitch(int argc, char** argv, const string& strSwitch, unsigned int* pResult1)
{
	if (!pResult1) 
		return false;
	string strLowerSwitch = makeLower(strSwitch);
	for (int i = 1; i < argc - 1; i++)
	{
		string strArg = makeLower(argv[i]);
		if ((strArg.find(strLowerSwitch) == 1) && 
			((strArg[0] == '/') || (strArg[0] == '-')))
		{
			*pResult1 = atoi(argv[i + 1]);
			return true;
		}
	}
	return false;
}

// Look for a command line switch with the given name and followed by two integer parameters
bool getSwitch(int argc, char** argv, const string& strSwitch, int* pResult1, int* pResult2)
{
	if ((!pResult1) || (!pResult2))
		return false;
	string strLowerSwitch = makeLower(strSwitch);
	for (int i = 1; i < argc - 2; i++)
	{
		string strArg = makeLower(argv[i]);
		if ((strArg.find(strLowerSwitch) == 1) && 
			((strArg[0] == '/') || (strArg[0] == '-')))
		{
			*pResult1 = atoi(argv[i + 1]);
			*pResult2 = atoi(argv[i + 2]);
			return true;
		}
	}
	return false;
}


